package com.fs.course.service;

import java.util.List;

import com.fs.common.core.domain.R;
import com.fs.course.domain.FsUserTalentFollow;
import com.fs.course.param.FsUserTalentFansParam;
import com.fs.course.vo.FsUserTalentFansVo;
import com.fs.course.vo.FsUserTalentFollowVo;

/**
 * 达人关注Service接口
 *
 * @author fs
 * @date 2024-05-31
 */
public interface IFsUserTalentFollowService
{
    /**
     * 查询达人关注
     *
     * @param id 达人关注主键
     * @return 达人关注
     */
    public FsUserTalentFollow selectFsUserTalentFollowById(Long id);

    /**
     * 查询达人关注列表
     *
     * @param fsUserTalentFollow 达人关注
     * @return 达人关注集合
     */
    public List<FsUserTalentFollow> selectFsUserTalentFollowList(FsUserTalentFollow fsUserTalentFollow);

    /**
     * 新增达人关注
     *
     * @param fsUserTalentFollow 达人关注
     * @return 结果
     */
    public int insertFsUserTalentFollow(FsUserTalentFollow fsUserTalentFollow);

    /**
     * 修改达人关注
     *
     * @param fsUserTalentFollow 达人关注
     * @return 结果
     */
    public int updateFsUserTalentFollow(FsUserTalentFollow fsUserTalentFollow);

    /**
     * 批量删除达人关注
     *
     * @param ids 需要删除的达人关注主键集合
     * @return 结果
     */
    public int deleteFsUserTalentFollowByIds(Long[] ids);

    /**
     * 删除达人关注信息
     *
     * @param id 达人关注主键
     * @return 结果
     */
    public int deleteFsUserTalentFollowById(Long id);

    R checkFollow(Long talentId, long userId);

    int deleteFollow(Long talentId, long userId);

    Integer queryFansCount(Long talentId);

    Integer queryIdolCount(Long userId);

    List<FsUserTalentFansVo> selectFsUserTalentFansVoList(FsUserTalentFansParam param);

    List<FsUserTalentFollowVo> selectFsUserFollowVoList(FsUserTalentFansParam param);
}
